#include <EEPROM.h>

// OutletTimer
// v1.0 Erwin Ried

/*

  Coil                             Relay
  [ analog  ]-                     -
  [ 5v      ]-     ^               D    |
  [ gnd     ]-     ! current       +    +--AC--+

Nothing pressed, 5V
4 2 6 6 4 2 6
10 8 3 8

Pressed, 5V

*/

#define LED_GREEN 0
#define LED_RED 1
#define RELAY 2
#define COIL A2
#define EEPROM_SAVE 10
#define SENSOR_LIMIT 900

byte currentDelay = 0;

void setup()
{
  pinMode(LED_GREEN, OUTPUT);
  pinMode(LED_RED, OUTPUT);
  pinMode(RELAY, OUTPUT);
  currentDelay = EEPROM.read(EEPROM_SAVE);
  //analogReference(INTERNAL);
  
  // Initialization
  switches(false, true);
  relay(true);
}

long newTimeout = 0, newTimeout2=0;
byte minutes = 0;
void loop()
{
  //Serial.begin(9600);
  /*while(true)
  {
    //switches(isButtonPressed(), true);
    switches(false, true);
    int ss = senseCoilMax();
    switches(false, false);
    
    for(int s1=0;s1<ss;s1+=10)
    {
      switches(true, false);
      delay(100);
      switches(false, false);
      delay(500);
    }
    delay(500);
    
    //Serial.println(isButtonPressed() ? "yes":"no");
  }*/
  
  // Check if user wants to set a new limit
  newTimeout = millis()+4000;
  do
  {
    if(isButtonPressed())
    {
      // Set new limit
      switches(false, false);
      setNewLimit();
    }
  }
  while(millis()<newTimeout);
  
  // Run out timer
  minutes = 0;
  switches(false, true);
  do
  {
    newTimeout = millis()+60000;
    do
    {
      if(currentDelay==1 && minutes>20)
        switches(false,false);
      
      if(isButtonPressed())
      {
        // Allow to stop
        newTimeout-=5000;
        newTimeout2= millis()+5000;
        do
        {
          switches(false, false);
          if(!isButtonPressed())
          {
            newTimeout2=0;
            newTimeout=0;
            currentDelay=0;
          }
          switches(false, true);
        }
        while(millis()<newTimeout2);    
      }
      switches(false,true);
    }
    while(millis()<newTimeout);
    
    switches(false, true);
    minutes++;
    
    if(minutes>=30)
    {
      minutes=0;
      currentDelay--;
    }
  }
  while(currentDelay>0);
  
  // Power off
  switches(true, true);
  delay(3000);
  relay(false);
  while(true)
  {
  }
}


